/**
 * fNX
 * @author Shogo
 */


public class ShComplex implements ShNumber
{
	protected ShReal re, im;
	
	public ShComplex()
	{
		this.re = ShReal.ZERO;
		this.im = ShReal.ZERO;
	}
	
	public ShComplex(ShReal re)
	{
		this.re = re;
		this.im = ShReal.ZERO;
	}
	
	public ShComplex(ShReal re, ShReal im)
	{
		this.re = re;
		this.im = im;
	}
	
	public ShReal getRe()
	{
		return re;
	}
	
	public ShReal getIm()
	{
		return im;
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShNumber add(ShNumber number)
	{
		ShComplex c = number.toShComplex();
		ShReal out_re, out_im;
		out_re = re.add(c.re);
		out_im = im.add(c.im);
		return new ShComplex(out_re, out_im);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShNumber sub(ShNumber number)
	{
		ShComplex c = number.toShComplex();
		ShReal out_re, out_im;
		out_re = re.sub(c.re);
		out_im = im.sub(c.im);
		return new ShComplex(out_re, out_im);
	}
	
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShNumber mul(ShNumber number)
	{
		ShComplex c = number.toShComplex();
		ShReal out_re, out_im;
		out_re = re.mul(c.re);
		out_re = out_re.sub(im.mul(c.im));
		out_im = im.mul(c.re);
		out_im = out_im.add(re.mul(c.im));
		return new ShComplex(out_re, out_im);
	}
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	public ShNumber div(ShNumber number)
	{
		ShComplex c = number.toShComplex();
		ShReal len;
		ShReal out_re, out_im;
		len = c.re.mul(c.re);
		len = len.add(c.im.mul(c.im));
		out_re = re.mul(c.re);
		out_re = out_re.add(im.mul(c.im));
		System.out.println(out_re);
		out_im = im.mul(c.re);
		out_im = out_im.sub(re.mul(c.im));
		return new ShComplex(out_re.div(len), out_im.div(len));
	}
	
	/**
	 * f`ɕϊlԂ
	 * @return fɕϊl
	 */
	public ShComplex toShComplex()
	{
		return this;
	}
	
	public String toString()
	{
		return re.toString() + "+(" + im.toString() + ")i";
	}
	
	public ShReal abs()
	{
		ShReal res;
		res = re.mul(re);
		res = res.add(im.mul(im));
		return ShReal.sqrt(res);
	}

	/************** ȉlZCu̕fg **************/
	
	/**
	 * IC[eShReallŗݏ悵lԂB
	 * @param val w肵w
	 * @return e^val̒l
	 */
	public static ShReal exp(ShReal val)
	{
		return ShReal.exp(val);
	}
	
	/**
	 * IC[eShReallŗݏ悵lԂB
	 * @param val w肵w
	 * @return e^val̒l
	 */
	public static ShComplex exp(ShComplex val)
	{
		ShReal r = ShReal.exp(val.getRe());
		ShReal x = ShReal.cos(val.getIm());
		ShReal y = ShReal.sin(val.getIm());
		return (ShComplex)r.mul(new ShComplex(y, x));
	}

	/**
	 * IC[eShReallŗݏ悵lԂB
	 * @param val w肵w
	 * @return e^val̒l
	 */
	public static ShNumber exp(ShNumber val)
	{
		if(val instanceof ShComplex)
		{
			return exp((ShComplex)val);
		}
		return ShReal.exp((ShReal)val);
	}

	/**
	 * IC[eƂΐ߂B
	 *
	 * ̊֐͕fɑ΂ĊgĂA̐邱Ƃł܂B
	 * @param val 0łȂ
	 * @return val̑ΐ
	 */
	public static ShNumber log(ShReal val)
	{
		if(val.sign()>0)
		{
			return ShReal.log(val);
		}
		return new ShComplex(ShReal.log(val.abs()), ShReal.PI);
	}
	
	/**
	 * IC[eƂΐ߂B
	 * 
	 * ߂l̋-PI`PIɐ܂B
	 * @param val 0łȂf
	 * @return val̑ΐ
	 */
	public static ShComplex log(ShComplex val)
	{
		return new ShComplex(ShReal.log(val.abs()), ShReal.atan2(val.getIm(), val.getRe()));
	}

	/**
	 * IC[eƂΐ߂B
	 * @param val 0łȂ
	 * @return val̑ΐ
	 */
	public static ShNumber log(ShNumber val)
	{
		if(val instanceof ShComplex)
		{
			return log((ShComplex)val);
		}
		return log((ShReal)val);
	}

	/**
	 * pΐ߂B
	 *
	 * ̊֐͕fɑ΂ĊgĂA̐łł܂B
	 * @param val 0łȂ
	 * @return val̏pΐ
	 */
	public static ShNumber log10(ShReal val)
	{
		return log(val).div(ShReal.LOG10);
	}

	/**
	 * pΐ߂
	 * @param val 0łȂf
	 * @return val̏pΐ
	 */
	public static ShComplex log10(ShComplex val)
	{
		return (ShComplex)log(val).div(ShReal.LOG10);
	}
	
	/**
	 * pΐ߂
	 * @param val 0łȂ
	 * @return val̏pΐ
	 */
	public static ShNumber log10(ShNumber val)
	{
		return log(val).div(ShReal.LOG10);
	}

}